Page MenuHomePhabricator

Deploy Skin:Slate to production
Closed, DeclinedPublic

Description

Slate is a new skin based off of Vector.

Event Timeline

Prtksxna created this task.Feb 11 2015, 6:15 AM
Prtksxna raised the priority of this task from to Normal.
Prtksxna updated the task description. (Show Details)
Prtksxna added a subscriber: Prtksxna.
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptFeb 11 2015, 6:15 AM
Legoktm updated the task description. (Show Details)Feb 11 2015, 6:18 AM
Legoktm set Security to None.
Legoktm added a subscriber: greg.

Are you sure it is different enough to be a separate skin?

fbstj added a subscriber: fbstj.Feb 11 2015, 8:20 AM

I'm curious as to why this is a separate Skin. If this was discussed or approved somewhere, please reference that (or have him/her comment here).

Intuitively, I'd think that:

  • To make Vector better, submit patches directly against Vector.
  • A/B testing or opt-in changes to gather feedback, use VectorBeta.

If sticking to a separate extension, beware of continued maintenance overhead of having to stay in sync with Vector. Also, what is the strategy for promoting this to users? Should it be exposed as a user preference? Or a hidden skin mode for direct url use only. What are the goals to conclude success/failure of the project? (E.g. should it replace Vector one day, or if not, is it meant to be temporary?)

Most existing software (extensions, gadgets) will not work with this skin due to the skin often being used as identifier of the environment. It's unlikely other developers are interested in maintaining compatibility with an additional skin.

Intuitively, I'd think that:

  • To make Vector better, submit patches directly against Vector.
  • A/B testing or opt-in changes to gather feedback, use VectorBeta.

Agreed, seems appropriate to use VectorBeta with a beta preference instead.

I'm curious as to why this is a separate Skin.

It's a separate skin because it will ultimately look a lot different and that's the point of skins. :-)

Intuitively, I'd think that:

  • To make Vector better, submit patches directly against Vector.

This makes sense, to a point. However in discussions about this approach, it didn't make much sense to (for example) kill all of the gradients in Vector as that seems to be a major piece of Vector's identity. Skins look different, so it makes sense to have different skins. Do you disagree?

  • A/B testing or opt-in changes to gather feedback, use VectorBeta.

Is VectorBeta still alive? I thought that was long dead. In any case, the idea isn't to improve Vector, per se, it's to use Vector as a base for a new skin.

If sticking to a separate extension, beware of continued maintenance overhead of having to stay in sync with Vector. Also, what is the strategy for promoting this to users? Should it be exposed as a user preference? Or a hidden skin mode for direct url use only.

There will be some kind of one-click opt-in feature.

What are the goals to conclude success/failure of the project? (E.g. should it replace Vector one day, or if not, is it meant to be temporary?)
Most existing software (extensions, gadgets) will not work with this skin due to the skin often being used as identifier of the environment.

This sounds like we may need to update some extensions or gadgets. Any extension or gadget that works with both Monobook and Vector should also work with a new skin. In theory, anyway!

It's unlikely other developers are interested in maintaining compatibility with an additional skin.

Agreed, but again, we already support at least four skins, so adding a fifth shouldn't be an issue, as far as I can tell.

Glaisher updated the task description. (Show Details)Feb 11 2015, 3:55 PM
Glaisher added a subscriber: Glaisher.
  • A/B testing or opt-in changes to gather feedback, use VectorBeta.

Is VectorBeta still alive? I thought that was long dead. In any case, the idea isn't to improve Vector, per se, it's to use Vector as a base for a new skin.

That makes sense, but only if the goal is for Slate to replace Vector as the default skin for Wikimedia wikis.

If sticking to a separate extension, beware of continued maintenance overhead of having to stay in sync with Vector. Also, what is the strategy for promoting this to users? Should it be exposed as a user preference? Or a hidden skin mode for direct url use only.

There will be some kind of one-click opt-in feature.

What are the goals to conclude success/failure of the project? (E.g. should it replace Vector one day, or if not, is it meant to be temporary?)
Most existing software (extensions, gadgets) will not work with this skin due to the skin often being used as identifier of the environment.

This sounds like we may need to update some extensions or gadgets. Any extension or gadget that works with both Monobook and Vector should also work with a new skin. In theory, anyway!

Existing software that supports Vector could support Slate. If the differences are kept to a minimum, it most likely can. However existing software does not support Slate by default. Skins use identifiers, and as such, by default nothing supports it.

It's unlikely other developers are interested in maintaining compatibility with an additional skin.

Agreed, but again, we already support at least four skins, so adding a fifth shouldn't be an issue, as far as I can tell.

Our software at large most definitely does not support four skins. We're maintaining four skins (some even argue that). Extensions tend to support Vector. Sometimes MonoBook. Unless if skin is Vector is considered support. I guess it constitutes support, as it ensures the pages with other skins don't break with incompatible modifications.

That makes sense, but only if the goal is for Slate to replace Vector as the default skin for Wikimedia wikis.

Probably, yeah. This task isn't premature exactly, but it's not ready to be acted on. I'm not sure if there's a better way this can be expressed in Phabricator. Stalled, kind of? Maybe there's a tag/project we can associate.

Existing software that supports Vector could support Slate. If the differences are kept to a minimum, it most likely can. However existing software does not support Slate by default. Skins use identifiers, and as such, by default nothing supports it.

I think what you're saying makes a good argument for using Vector as a base, which Slate is doing. And I think we'll probably maybe keep changes to a minimum, but I also don't want the code to dictate the design, so we may re-group things as necessary. Being able to make "breaking" changes to the HTML API, such that it is, also seems like a pretty good argument for creating a new skin.

We can't and won't guarantee no breaking changes in a new skin. I think we can use Vector as a base and try to mitigate and minimize any breakages. I'm also thinking that if we move toward a responsive layout, the groupings and layout may need to be re-thought entirely, which of course may be incompatible with some gadgets and scripts and who knows what else.

Outside of this skin specifically, it's also a matter of us cleaning house a bit. We may need to centralize gadgets and other tools so that it isn't so damned awful and expensive to make future changes. Compare with MediaWiki extensions, which are all in Git and can be grepped through.

We also may need to invest in infrastructure that makes it easier and more stable for scripts to hook into the user interface. If we plan ahead and look at real world use-cases to address, we can create a reasonably stable interface. Maybe. Or not. But this isn't to say that Slate is going to solve MediaWiki skinning, by any means, we'll just try not to make it any worse. :-)

This task isn't premature exactly, but it's not ready to be acted on. I'm not sure if there's a better way this can be expressed in Phabricator. Stalled, kind of?

Yes. There's a status for that.

Quiddity changed the task status from Open to Stalled.Feb 12 2015, 11:08 PM
Quiddity added a subscriber: Quiddity.
fbstj removed a subscriber: fbstj.Dec 15 2015, 2:55 PM
Peachey88 closed this task as Declined.Mar 11 2016, 12:27 AM
Peachey88 added a subscriber: Peachey88.

Changing status to declined, Skin is no longer maintained per T123209.

Restricted Application removed a subscriber: Liuxinyu970226. · View Herald TranscriptMar 11 2016, 12:28 AM